/*
 * Copyright (c) 2004-2006 PADL Software Pty Ltd.
 * All rights reserved.
 * Use is subject to license.
 */

#ifndef _PAM_LOCALPWCHECK_H
#define _PAM_LOCALPWCHECK_H 1

#ifdef HAVE_SECURITY_PAM_APPL_H
#include <security/pam_appl.h>
#elif defined(HAVE_PAM_PAM_APPL_H)
#include <pam/pam_appl.h>
#endif

#ifdef HAVE_SECURITY_PAM_MISC_H
#include <security/pam_misc.h>
#elif defined(HAVE_PAM_PAM_MISC_H)
#include <pam/pam_misc.h>
#endif

#ifndef HAVE_PAM_PAM_MODULES_H
#include <security/pam_modules.h>
#else
#include <pam/pam_modules.h>
#endif

#ifndef _PATH_PASSWD
#define _PATH_PASSWD "/etc/passwd"
#endif

#ifndef _PATH_SHADOW
#define _PATH_SHADOW "/etc/shadow"
#endif

#ifndef _PATH_OPASSWD
#define _PATH_OPASSWD "/etc/security/opasswd"
#endif

#ifndef _PATH_NOPASSWD
#define _PATH_NOPASSWD "/etc/security/nopasswd"
#endif

/* from pam_ldap.h */

#if defined(HAVE_SECURITY_PAM_MISC_H) || defined(HAVE_PAM_PAM_MISC_H)
 /* FIXME: is there something better to check? */
#define CONST_ARG const
#else
#define CONST_ARG
#endif

#ifndef PAM_EXTERN
#define PAM_EXTERN
#endif

#ifndef _pam_overwrite
#define _pam_overwrite(x) \
{ \
     register char *__xx__; \
     if ((__xx__=x)) \
          while (*__xx__) \
               *__xx__++ = '\0'; \
}
#endif

#ifndef _pam_drop
#define _pam_drop(X) \
if (X) { \
    free(X); \
    X=NULL; \
}
#endif

#define OLD_PASSWORD_PROMPT		"Enter existing login password: "
#define NEW_PASSWORD_PROMPT		"New Password: "
#define AGAIN_PASSWORD_PROMPT		"Re-enter new Password: "


typedef struct _lpw_policy {
#define LPW_FLAGS_DEBUG			0x0001
#define LPW_FLAGS_USE_AUTHTOK		0x0002
#define LPW_FLAGS_GET_OLDAUTHTOK	0x0004
#define LPW_FLAGS_VALIDATE_OLDAUTHTOK	0x0008
	int flags;

#define LPW_MIN_LENGTH			8
	int min_length;

#define LPW_MIN_CLASSES			3
	int min_classes;

#define LPW_MAX_TRIES			3
	int max_tries;

#define LPW_HISTORY_LENGTH		-1
	int history_length;

#define LPW_CHECK_LENGTH		-1
	int check_length;
} lpw_policy_t;

#define PADL_LPW_POLICY_DATA "PADL-LPW-POLICY-DATA"

/* PAM password changing routine */
#define PAM_SM_PASSWORD
PAM_EXTERN int pam_sm_chauthtok (pam_handle_t *, int, int, const char **);

/* History stuff that should NOT be exported */
int save_old_password(const char *forwho, const char *oldpass, size_t oldpasslen, int howmany);
int check_old_password(const char *forwho, const char *newpass, size_t newpasslen);

#endif /* _PAM_LOCALPWCHECK_H */

